package selsl

import "testing"

func TestRootType(t *testing.T) {
	name := Send(RootType, "name", nil, nil)
	nameString := string(name.(String))
	if nameString != "Type" {
		t.Errorf("Root type name wrong: %v", name)
	}
	t.Logf("Name root type: %s", nameString)
}

func TestStringType(t *testing.T) {
	raw := "banana"
	str := String(raw)
	name := Send(str, "name", nil, nil)
	nameString := string(name.(String))
	if nameString != raw {
		t.Errorf("String type name wrong: %v", name)
	}
	t.Logf("Name string type: %s", nameString)
}

func TestListType(t *testing.T) {
	raw := [ "apple", "banana", "pear" ]
	list :=  List{ String(raw[0]),
				String(raw[1]),
				String(raw[2]) }
	clone := list.Clone()
	clone[1] = String("cumquat")

}

